﻿Public Class frmMain
#Region "Form Closing 'Save Changes' Dialog"
    Private Sub frmMain_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        Try
            Dim Response As MsgBoxResult
            If CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = True Then
                Response = MsgBox("Save changes to " + TabControl1.SelectedTab.Text + " ?", _
                                  MsgBoxStyle.Exclamation + MsgBoxStyle.YesNo, _
                                  "JunkPad")

                If Response = MsgBoxResult.No Then
                    CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text = ""
                    Me.Text = "JunkPad - " + TabControl1.SelectedTab.Text
                End If
                If Response = MsgBoxResult.Yes Then
                    ' Create a SaveFileDialog to request a path and file name to save to. 
                    Dim saveFile1 As New SaveFileDialog()

                    ' Initialize the SaveFileDialog to specify the RTF extention for the file.
                    saveFile1.DefaultExt = "*.dild"
                    saveFile1.Filter = "DILD Text Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf|Plain Text Files (*.txt)|*.txt|Batch Files (*.bat)|*.bat|DOC Files (*.doc)|*.doc|HTML Files (*.html)|*.html|All files (*.*)|*.*"

                    ' Determine whether the user selected a file name from the saveFileDialog. 
                    If (saveFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                        And (saveFile1.FileName.Length > 0) Then

                        ' Save the contents of the RichTextBox into the file.
                        CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SaveFile(saveFile1.FileName)
                    End If
                End If
            Else
                End
            End If
        Catch Ex As Exception

        End Try
    End Sub
#End Region
#Region "Character Counter on KeyPress"
    Private Sub frmMain_KeyPress(sender As Object, e As KeyPressEventArgs) Handles Me.KeyPress
        Dim str As String
        str = CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).TextLength
        str = str + 1
        lblCharCount.Text = "Characters: " + str
    End Sub
#End Region
#Region "Initialize all tabs"
    Private Sub frmMain_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim richtext As New RichTextBox
        Dim edittab As New TabPage
        edittab.Controls.Add(richtext)
        richtext.Dock = DockStyle.Fill
        TabControl1.TabPages.Add(edittab)
        TabControl1.SelectTab(edittab)
        TabControl1.SelectedTab.Text = "unnamed"
        Me.Text = "JunkPad - " + TabControl1.SelectedTab.Text
    End Sub
#End Region
#Region "Standard Save Dialog"
    Private Sub SaveAsToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SaveAsToolStripMenuItem.Click
        Try
            ' Create a SaveFileDialog to request a path and file name to save to. 
            Dim saveFile1 As New SaveFileDialog()

            ' Initialize the SaveFileDialog to specify the RTF extention for the file.
            saveFile1.DefaultExt = "*.dild"
            saveFile1.Filter = "DILD Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf"

            ' Determine whether the user selected a file name from the saveFileDialog. 
            If (saveFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                And (saveFile1.FileName.Length > 0) Then

                ' Save the contents of the RichTextBox into the file.
                CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SaveFile(saveFile1.FileName)
                TabControl1.SelectedTab.Text = saveFile1.FileName
            End If
            Me.Text = "JunkPad - " + TabControl1.SelectedTab.Text
        Catch ex As Exception
            MessageBox.Show("Can't save a non-existant tab!", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
#End Region

#Region "Tab Name Control - DoubleClick"
    Private Sub TabControl1_DoubleClick1(sender As Object, e As EventArgs) Handles TabControl1.DoubleClick
        Try
            CType(frmRename.Controls.Item("txtBoxName"), TextBox).Text = TabControl1.SelectedTab.Text
            frmRename.ShowDialog()
            TabControl1.SelectedTab.Text = CType(frmRename.Controls.Item("txtBoxName"), TextBox).Text
            Me.Text = "JunkPad - " + TabControl1.SelectedTab.Text
        Catch Ex As Exception
            MessageBox.Show("No tabs to rename.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try
    End Sub
#End Region
#Region "Tab Name Control - Button"
    Private Sub btnRename_Click(sender As Object, e As EventArgs) Handles btnRename.Click
        Try
            CType(frmRename.Controls.Item("txtBoxName"), TextBox).Text = TabControl1.SelectedTab.Text
            frmRename.ShowDialog()
            TabControl1.SelectedTab.Text = CType(frmRename.Controls.Item("txtBoxName"), TextBox).Text
            Me.Text = "JunkPad - " + TabControl1.SelectedTab.Text
        Catch Ex As Exception
            MessageBox.Show("No tabs to rename.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try
    End Sub
    'Below is for the Tabcontrol Toolstrip
    Private Sub RenameTabToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles RenameTabToolStripMenuItem.Click
        Try
            CType(frmRename.Controls.Item("txtBoxName"), TextBox).Text = TabControl1.SelectedTab.Text
            frmRename.ShowDialog()
            TabControl1.SelectedTab.Text = CType(frmRename.Controls.Item("txtBoxName"), TextBox).Text
            Me.Text = "JunkPad - " + TabControl1.SelectedTab.Text
        Catch Ex As Exception
            MessageBox.Show("No tabs to rename.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try
    End Sub
#End Region
#Region "Add new tab"
    Private Sub btnNew_Click(sender As Object, e As EventArgs) Handles btnNew.Click
        Dim richtext As New RichTextBox
        Dim edittab As New TabPage
        edittab.Controls.Add(richtext)
        richtext.Dock = DockStyle.Fill
        TabControl1.TabPages.Add(edittab)
        TabControl1.SelectTab(edittab)
        TabControl1.SelectedTab.Text = "unnamed"
        Me.Text = "JunkPad - " + TabControl1.SelectedTab.Text
    End Sub
    ' Below is for the TabControl Toolstrip.
    Private Sub NewTabToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles NewTabToolStripMenuItem.Click
        Dim richtext As New RichTextBox
        Dim edittab As New TabPage
        edittab.Controls.Add(richtext)
        richtext.Dock = DockStyle.Fill
        TabControl1.TabPages.Add(edittab)
        TabControl1.SelectTab(edittab)
        TabControl1.SelectedTab.Text = "unnamed"
        Me.Text = "JunkPad - " + TabControl1.SelectedTab.Text
    End Sub
#End Region
#Region "Close Tab"
    Private Sub btnCloseTab_Click(sender As Object, e As EventArgs) Handles btnCloseTab.Click
        Dim Response As MsgBoxResult
        Try
            If CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = True Then
                Response = MsgBox("Save changes to " + TabControl1.SelectedTab.Text + " ?", _
                                  MsgBoxStyle.Exclamation + MsgBoxStyle.YesNo, _
                                  "JunkPad")
                If Response = MsgBoxResult.No Then
                    TabControl1.TabPages.Remove(TabControl1.SelectedTab)
                End If
                If Response = MsgBoxResult.Yes Then
                    ' Create a SaveFileDialog to request a path and file name to save to. 
                    Dim saveFile1 As New SaveFileDialog()

                    ' Initialize the SaveFileDialog to specify the RTF extention for the file.
                    saveFile1.DefaultExt = "*.dild"
                    saveFile1.Filter = "DILD Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf|Plain Text Files (*.txt)|*.txt|Batch Files (*.bat)|*.bat|All files (*.*)|*.*"

                    ' Determine whether the user selected a file name from the saveFileDialog. 
                    If (saveFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                        And (saveFile1.FileName.Length > 0) Then

                        ' Save the contents of the RichTextBox into the file.
                        CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SaveFile(saveFile1.FileName)
                    End If
                    TabControl1.TabPages.Remove(TabControl1.SelectedTab)
                End If
            Else
                TabControl1.TabPages.Remove(TabControl1.SelectedTab)
            End If
        Catch
            MessageBox.Show("No tabs are open.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try
    End Sub

    Private Sub CloseTabToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles CloseTabToolStripMenuItem.Click
        Dim Response As MsgBoxResult
        Try
            If CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = True Then
                Response = MsgBox("Save changes to " + TabControl1.SelectedTab.Text + " ?", _
                                  MsgBoxStyle.Exclamation + MsgBoxStyle.YesNo, _
                                  "JunkPad")
                If Response = MsgBoxResult.No Then
                    TabControl1.TabPages.Remove(TabControl1.SelectedTab)
                End If
                If Response = MsgBoxResult.Yes Then
                    ' Create a SaveFileDialog to request a path and file name to save to. 
                    Dim saveFile1 As New SaveFileDialog()

                    ' Initialize the SaveFileDialog to specify the RTF extention for the file.
                    saveFile1.DefaultExt = "*.dild"
                    saveFile1.Filter = "DILD Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf|Plain Text Files (*.txt)|*.txt|Batch Files (*.bat)|*.bat|All files (*.*)|*.*"

                    ' Determine whether the user selected a file name from the saveFileDialog. 
                    If (saveFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                        And (saveFile1.FileName.Length > 0) Then

                        ' Save the contents of the RichTextBox into the file.
                        CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SaveFile(saveFile1.FileName)
                    End If
                    TabControl1.TabPages.Remove(TabControl1.SelectedTab)
                End If
            Else
                TabControl1.TabPages.Remove(TabControl1.SelectedTab)
            End If
        Catch
            MessageBox.Show("No tabs are open.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try
    End Sub
#End Region
#Region "Standard Open Dialog (overwrite current tab)"
    Private Sub OpenInThisTabToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles OpenInThisTabToolStripMenuItem.Click
        Dim openFile1 As New OpenFileDialog()
        Dim Response As MsgBoxResult
        If CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = True Then
            Response = MsgBox("Save changes to " + TabControl1.SelectedTab.Text + " ?", _
                              MsgBoxStyle.Exclamation + MsgBoxStyle.YesNo, _
                              "JunkPad")
            If Response = MsgBoxResult.No Then
                Try
                    ' Initialize the OpenFileDialog to look for RTF files.
                    openFile1.DefaultExt = "*.dild"
                    openFile1.Filter = "DILD Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf|Plain Text Files (*.txt)|*.txt|Batch Files (*.bat)|*.bat|All files (*.*)|*.*"

                    ' Determine whether the user selected a file from the OpenFileDialog. 
                    If (openFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                        And (openFile1.FileName.Length > 0) Then

                        ' Load the contents of the file into the RichTextBox.
                        CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).LoadFile(openFile1.FileName)
                        TabControl1.SelectedTab.Text = openFile1.SafeFileName
                        Me.Text = "JunkPad - " + TabControl1.SelectedTab.Text
                    End If
                Catch ex As Exception
                    MessageBox.Show("No tabs are open. Please add a tab before trying to open a file.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End Try
            End If
            If Response = MsgBoxResult.Yes Then
                ' Create a SaveFileDialog to request a path and file name to save to. 
                Dim saveFile1 As New SaveFileDialog()

                ' Initialize the SaveFileDialog to specify the RTF extention for the file.
                saveFile1.DefaultExt = "*.dild"
                saveFile1.Filter = "DILD Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf|Plain Text Files (*.txt)|*.txt|Batch Files (*.bat)|*.bat|DOC Files (*.doc)|*.doc|HTML Files (*.html)|*.html|All files (*.*)|*.*"

                ' Determine whether the user selected a file name from the saveFileDialog. 
                If (saveFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                    And (saveFile1.FileName.Length > 0) Then

                    ' Save the contents of the RichTextBox into the file.
                    CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SaveFile(saveFile1.FileName)
                End If
                Try
                    ' Initialize the OpenFileDialog to look for RTF files.
                    openFile1.DefaultExt = "*.dild"
                    openFile1.Filter = "DILD Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf|Plain Text Files (*.txt)|*.txt|Batch Files (*.bat)|*.bat|All files (*.*)|*.*"

                    ' Determine whether the user selected a file from the OpenFileDialog. 
                    If (openFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                        And (openFile1.FileName.Length > 0) Then

                        ' Load the contents of the file into the RichTextBox.
                        CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).LoadFile(openFile1.FileName)
                        TabControl1.SelectedTab.Text = openFile1.SafeFileName
                        Me.Text = "JunkPad - " + TabControl1.SelectedTab.Text
                    End If
                Catch ex As Exception
                    MessageBox.Show("No tabs are open. Please add a tab before trying to open a file.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End Try
            End If
        Else
            Try
                ' Initialize the OpenFileDialog to look for RTF files.
                openFile1.DefaultExt = "*.dild"
                openFile1.Filter = "DILD Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf|Plain Text Files (*.txt)|*.txt|Batch Files (*.bat)|*.bat|All files (*.*)|*.*"

                ' Determine whether the user selected a file from the OpenFileDialog. 
                If (openFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                    And (openFile1.FileName.Length > 0) Then

                    ' Load the contents of the file into the RichTextBox.
                    CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).LoadFile(openFile1.FileName)
                    TabControl1.SelectedTab.Text = openFile1.SafeFileName
                    Me.Text = "JunkPad - " + TabControl1.SelectedTab.Text
                End If
            Catch ex As Exception
                MessageBox.Show("No tabs are open. Please add a tab before trying to open a file.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        End If
    End Sub
#End Region
#Region "Standard Open Dialog"
    Private Sub OpenToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles OpenToolStripMenuItem.Click
        Dim openFile1 As New OpenFileDialog()
        Try
            ' Initialize the OpenFileDialog to look for RTF files.
            openFile1.DefaultExt = "*.dild"
            openFile1.Filter = "DILD Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf"

            ' Determine whether the user selected a file from the OpenFileDialog. 
            If (openFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                And (openFile1.FileName.Length > 0) Then

                ' Load the contents of the file into the RichTextBox.
                Dim richtext As New RichTextBox
                Dim edittab As New TabPage
                edittab.Controls.Add(richtext)
                richtext.Dock = DockStyle.Fill
                TabControl1.TabPages.Add(edittab)
                TabControl1.SelectTab(edittab)
                CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).LoadFile(openFile1.FileName)
                TabControl1.SelectedTab.Text = openFile1.SafeFileName
                Me.Text = "JunkPad - " + TabControl1.SelectedTab.Text
            End If

        Catch ex As Exception
            'Do nothing on Exception
        End Try
    End Sub
#End Region
#Region "Font Setup"
    Private Sub btnFont_Click(sender As Object, e As EventArgs) Handles btnFont.Click
        Try
            dlgFont.Font = CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont
            dlgFont.ShowDialog()
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont = dlgFont.Font
        Catch ex As Exception
            MessageBox.Show("No tabs to change font in.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try
    End Sub
#End Region


#Region "Editor Lock + Unlock"
    Private Sub btnLock_Click(sender As Object, e As EventArgs) Handles btnLock.Click
        TabControl1.Enabled = False
        btnUnlock.Enabled = True
        btnLock.Enabled = False
        btnOpen.Enabled = False
        btnNewTab.Enabled = False
        btnSave.Enabled = False
        'CloseTabToolStripMenuItem.Enabled = False
        btnCut.Enabled = False
        btnCopy.Enabled = False
        btnPaste.Enabled = False
        btnUndo.Enabled = False
        btnRedo.Enabled = False
    End Sub

    Private Sub btnUnlock_Click(sender As Object, e As EventArgs) Handles btnUnlock.Click
        TabControl1.Enabled = True
        btnUnlock.Enabled = False
        btnLock.Enabled = True
        btnOpen.Enabled = True
        NewFileInThisTabToolStripMenuItem.Enabled = True
        btnSave.Enabled = True
        'CloseTabToolStripMenuItem.Enabled = True
        btnCut.Enabled = True
        btnCopy.Enabled = True
        btnPaste.Enabled = True
        btnUndo.Enabled = True
        btnRedo.Enabled = True
    End Sub
#End Region
#Region "Counters"
    Private Sub WordsToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles WordsToolStripMenuItem.Click
        Try
            Dim str As String
            Dim i, l, words As Integer
            str = CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text
            str = LTrim(str) 'removes leading blank spaces
            str = RTrim(str) ' removes trailing blank spaces
            l = str.Length
            i = 0
            words = 0
            While (i < l)
                If str(i) = " " Then
                    words = words + 1
                    i = i + 1
                    While str(i) = " " ' removes continuous blank spaces
                        i = i + 1
                    End While
                Else
                    i = i + 1
                End If

            End While
            words = words + 1 ' adds the last word
            MessageBox.Show("Word count: " & words)
        Catch
            MessageBox.Show("No tabs to count words in.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try
    End Sub

    Private Sub LettersToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles LettersToolStripMenuItem.Click
        Try
            Dim str As String
            str = CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).TextLength
            MessageBox.Show("Letter count: " & str)
        Catch
            MessageBox.Show("No tabs to count letters in.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try
    End Sub

    Private Sub lblCharCount_Click(sender As Object, e As EventArgs) Handles lblCharCount.Click
        Dim str As String
        str = CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).TextLength
        MessageBox.Show("Letter count: " & str)
    End Sub
#End Region
#Region "Cut, Copy, Paste + Undo, Redo & Help"
    Private Sub btnCut_Click(sender As Object, e As EventArgs) Handles btnCut.Click
        CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Cut()
    End Sub

    Private Sub btnUndo_Click(sender As Object, e As EventArgs) Handles btnUndo.Click
        CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Undo()
    End Sub

    Private Sub btnRedo_Click(sender As Object, e As EventArgs) Handles btnRedo.Click
        CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Redo()
    End Sub

    Private Sub btnPaste_Click(sender As Object, e As EventArgs) Handles btnPaste.Click
        CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Paste()
    End Sub

    Private Sub btnCopy_Click(sender As Object, e As EventArgs) Handles btnCopy.Click
        CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Copy()
    End Sub

    Private Sub btnHelp_Click(sender As Object, e As EventArgs) Handles btnHelp.Click
        frmHelp.ShowDialog()
    End Sub
#End Region
#Region "Open other files"
    Private Sub OpenOtherFilesToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles OpenOtherFilesToolStripMenuItem.Click
        Dim Open As New OpenFileDialog()
        Dim myStreamReader As System.IO.StreamReader
        Open.Filter = "Text Files (*.txt)|*.txt|Rich Text Files (*.rtf)|*.rtf|DILD Files (*.dild)|*.dild|Batch Files (*.bat)|*.bat|DOC Files (*.doc)|*.doc|HTML Files (*.html)|*.html|All files (*.*)|*.*"
        Open.CheckFileExists = True
        Open.ShowDialog(Me)
        Try
            Open.OpenFile()
            myStreamReader = System.IO.File.OpenText(Open.FileName)
            Dim richtext As New RichTextBox
            Dim edittab As New TabPage
            edittab.Controls.Add(richtext)
            richtext.Dock = DockStyle.Fill
            TabControl1.TabPages.Add(edittab)
            TabControl1.SelectTab(edittab)
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text = myStreamReader.ReadToEnd()
            TabControl1.SelectedTab.Text = Open.SafeFileName
            Me.Text = "JunkPad - " + TabControl1.SelectedTab.Text
        Catch ex As Exception
            ' Do nothing on Exception
        End Try
    End Sub

    Private Sub OpenOtherFilesInThisTabToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles OpenOtherFilesInThisTabToolStripMenuItem.Click
        Dim Open As New OpenFileDialog()
        Dim myStreamReader As System.IO.StreamReader
        Open.Filter = "Text Files (*.txt)|*.txt|Rich Text Files (*.rtf)|*.rtf|DILD Files (*.dild)|*.dild|Batch Files (*.bat)|*.bat|DOC Files (*.doc)|*.doc|HTML Files (*.html)|*.html|All files (*.*)|*.*"
        Open.CheckFileExists = True
        Open.ShowDialog(Me)
        Try
            Open.OpenFile()
            myStreamReader = System.IO.File.OpenText(Open.FileName)
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text = myStreamReader.ReadToEnd()
            TabControl1.SelectedTab.Text = Open.SafeFileName
            Me.Text = "JunkPad - " + TabControl1.SelectedTab.Text
        Catch ex As Exception
            MessageBox.Show("No tabs are open. Please add a tab before trying to open a file.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
#End Region
#Region "Save other files"
    Private Sub SaveOtherFileToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SaveOtherFileToolStripMenuItem.Click
        Dim Save As New SaveFileDialog()
        Dim myStreamWriter As System.IO.StreamWriter
        Save.Filter = "Plain Text Files (*.txt)|*.txt|DILD Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf|Batch Files (*.bat)|*.bat|DOC Files (*.doc)|*.doc|HTML Files (*.html)|*.html|All files (*.*)|*.*"
        Save.CheckPathExists = True
        Save.ShowDialog(Me)
        Try
            myStreamWriter = System.IO.File.CreateText(Save.FileName)
            myStreamWriter.Write(CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text)
            myStreamWriter.Flush()
            TabControl1.SelectedTab.Text = Save.FileName
        Catch ex As Exception
            ' Do nothing on Exception
        End Try
    End Sub
#End Region
#Region "Start New File"
    Private Sub NewFileInThisTabToolStripMenuItem_Click_2(sender As Object, e As EventArgs) Handles NewFileInThisTabToolStripMenuItem.Click
        Dim Response As MsgBoxResult
        Try
            If CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = True Then
                Response = MsgBox("Save changes to " + TabControl1.SelectedTab.Text + " ?", _
                                  MsgBoxStyle.Exclamation + MsgBoxStyle.YesNo, _
                                  "JunkPad")

                If Response = MsgBoxResult.No Then
                    CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text = ""
                    Me.Text = "JunkPad - " + TabControl1.SelectedTab.Text
                End If
                If Response = MsgBoxResult.Yes Then
                    ' Create a SaveFileDialog to request a path and file name to save to. 
                    Dim saveFile1 As New SaveFileDialog()

                    ' Initialize the SaveFileDialog to specify the RTF extention for the file.
                    saveFile1.DefaultExt = "*.dild"
                    saveFile1.Filter = "DILD Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf|Plain Text Files (*.txt)|*.txt|Batch Files (*.bat)|*.bat|DOC Files (*.doc)|*.doc|HTML Files (*.html)|*.html|All files (*.*)|*.*"

                    ' Determine whether the user selected a file name from the saveFileDialog. 
                    If (saveFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                        And (saveFile1.FileName.Length > 0) Then

                        ' Save the contents of the RichTextBox into the file.
                        CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SaveFile(saveFile1.FileName)
                    End If
                    CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text = ""
                    Me.Text = "JunkPad - " + TabControl1.SelectedTab.Text
                End If
            End If
        Catch Ex As Exception
            MessageBox.Show("No tabs are open. Please add a tab before trying to start a new file.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
#End Region

#Region "Font Colour Setup"
    Private Sub btnColour_Click(sender As Object, e As EventArgs) Handles btnColour.Click
        Try
            dlgColor.Color = CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionColor
            dlgColor.ShowDialog()
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionColor = dlgColor.Color
        Catch ex As Exception
            MessageBox.Show("No tabs to change font colour in.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try
    End Sub
#End Region
#Region "Image & date + time insertation"
    Private Sub btnImage_Click(sender As Object, e As EventArgs) Handles btnImage.Click
            Dim openFile1 As New OpenFileDialog()
            Try
                ' Initialize the OpenFileDialog to look for RTF files.
                openFile1.DefaultExt = "*.jpg"
                openFile1.Filter = "JPEG (*.jpg, *.jpeg, *.jpe, *.jfif)|*.jpg|PNG (*.png)|*.png|GIF (*.gif)|*.gif|BMP (*.bmp, *.dib)|*.bmp|TIFF (*.tiff, *.tif)|*.tiff|All files (*.*)|*.*"

                ' Determine whether the user selected a file from the OpenFileDialog. 
                If (openFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                    And (openFile1.FileName.Length > 0) Then

                    ' Load the contents of the file into the RichTextBox.
                    Dim img As Image = Image.FromFile(openFile1.FileName)
                    Dim orgData = Clipboard.GetDataObject
                    Clipboard.SetImage(img)
                    CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Paste()
                End If
            Catch ex As Exception
                MessageBox.Show("Invalid image.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
    End Sub


    Private Sub btnTime_Click(sender As Object, e As EventArgs) Handles btnTime.Click
        Try
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectedText = DateAndTime.Now
        Catch ex As Exception
            MessageBox.Show("Cannot insert date and time into non-existant tab!", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
#End Region

    Private Sub btnSelectAll_Click(sender As Object, e As EventArgs) Handles btnSelectAll.Click
        CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectAll()
    End Sub
    Private Sub btnCloseAllTabs_Click(sender As Object, e As EventArgs) Handles btnCloseAllTabs.Click
        Try
            Dim name As TabPage = TabControl1.SelectedTab
            TabControl1.Controls.Remove(name)
            TabControl1.TabPages.Add(name)
            For i As Int32 = 0 To TabControl1.TabCount - 1
                TabControl1.Controls.Remove(TabControl1.TabPages(0))
            Next
        Catch EX As Exception
            MessageBox.Show("No tabs are open.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try
    End Sub
    'Below is for the Tabcontrol Toolstrip
    Private Sub CloseAllTabsToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles CloseAllTabsToolStripMenuItem.Click
        Try
            Dim name As TabPage = TabControl1.SelectedTab
            TabControl1.Controls.Remove(name)
            TabControl1.TabPages.Add(name)
            For i As Int32 = 0 To TabControl1.TabCount - 1
                TabControl1.Controls.Remove(TabControl1.TabPages(0))
            Next
        Catch EX As Exception
            MessageBox.Show("No tabs are open.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try
    End Sub
End Class